require 'AccueilDlgUi'
require 'DataManager'
require 'ClientsDlg'
require 'PropositionsDlg'
require 'RessourcesDlg'
require 'IncidentsDlg'
require 'ContratsDlg'
require 'PerformancesDlg'

# Class Accueil
#
# definition : Main application window

class AccueilDlg < AccueilDlgUi
 
		# constructor
    def initialize( name )
      super(nil, name)
      setCaption("Komptes")
  		@dataManager = DataManager.new
			#@dataManager.createConnection
			@dataManager.populateDataObjects
    end
		
		# slot called on a clic on the "quit" button
		# it asks datamanager to close the database connection
		def close(arg)
			@dataManager.closeConnection
			super(arg)
		end
		
		# displays the clients manager window
    def showClients
			clientsDlg = ClientsDlg.new(@dataManager)
			clientsDlg.exec
    end
		
		# displays the propositions manager window
		def showPropositions
			propositionsDlg = PropositionsDlg.new(@dataManager)
			propositionsDlg.exec
		end
		
		# displays the resources manager window
		def showRessources
			ressourcesDlg = RessourcesDlg.new(@dataManager)
			ressourcesDlg.exec
		end
		
		# display the incidents manager window
		def showIncidents
			incidentsDlg = IncidentsDlg.new(@dataManager)
			incidentsDlg.exec
		end
		
		# displays the contracts manager window
		def showContrats
			contratsDlg = ContratsDlg.new(@dataManager)
			contratsDlg.exec
		end
		
		# display the performances window
		def showPerformances
			performancesDlg = PerformancesDlg.new(@dataManager)
			performancesDlg.exec
		end
end


