# Classe Clients
#
# dfinition : gre la liste des clients

class Clients
	attr_reader :clients

	# constructeur
	def initialize
		@clients=[]
	end
	
	# Ajoute un client  la liste de clients existante
	def addClient(raison_sociale, div, dep, adresse, cp, ville, contact, telephone)
		@clients.push(Client.new(raison_sociale, div, dep, adresse, cp, ville, contact, telephone))
	end
	
	# Affiche la liste des clients sur la sortie standard
	def to_s
    puts("raison sociale | division | dpartement | contact | telephone")
    @clients.each {|client| puts(client.to_s())}
  end
  
	# Supprime de la liste de clients le client dont le nom est <nomclient>, la division est <div> et le dpartement <dep>
	def delClient(nomclient,div,dep)
		@clients.delete_if {|client| client.raison_sociale==nomclient and client.division==div and client.departement==dep}
  end
	
	# Renvoie l'objet client dont le nom est <nomclient>, la division <div> et le dpartement <dep>
	def getClient(nomclient,div,dep)
		@clients.each do |client|
			if (client.raison_sociale==nomclient and client.division==div and client.departement==dep) then 
				return client 
			end
		end
		return nil
	end
	
	def clean
		@clients = []
	end
	
	def length
		return @clients.length
	end
end

# Classe Client
#
# dfinition : Reprsente un client
# attributs :
# - raison_sociale : raison sociale
# - division : la division du client avec laquelle on a pass un contrat
# - departement : le departement de la division avec lequel on a pass un contrat
# - adresse
# - cp : code postal
# - ville
# - contact
# - telephone

class Client
  attr_reader :raison_sociale, :division, :departement, :adresse, :cp, :ville, :contact, :telephone
	
	# constructeur
	def initialize(raison_sociale, div, dep, adresse, cp, ville, contact, telephone)
    @raison_sociale = raison_sociale
		@division = div
		@departement = dep
		@adresse = adresse
		@cp = cp
		@ville = ville
    @contact = contact
    @telephone = telephone
  end
  
	# Affiche les informations du client sur la sortie standard
	def to_s
    "Client : #{@raison_sociale}, #{@division}, #{@departement}, #{@contact}, #{@telephone}"
  end
end
