# Classe Contrats
class Contrats
	attr_reader :contrats

	# constructeur
	def initialize
		@contrats=[]
	end
	
	# returns the contract identified by its reference <ref>
	def getContrat(ref)
		@contrats.each do |contrat|
			if contrat.reference==ref then
			 return contrat
			end
		end
		return nil
	end
	
	# Supprime de la liste de contrats le contrat dont la rfrence est <ref>
	def delContrat(ref)
		@contrats.delete_if {|contrat| contrat.reference==ref}
  end
	
	# Affiche la liste des contrats sur la sortie standard
	def to_s
    @contrats.each {|contrat| puts(contrat.to_s())}
  end
		
	def length
		return @contrats.length
	end
end


# Classe ContratsExpertise
#
# dfinition : gre une collection de contrats.

class ContratsExpertise < Contrats

	# Ajoute un contrat  la liste des contrats existante
	def addContrat(ref,titre,desc,date_deb,date_fin,nb_jours,montant_jour)
		@contrats.push(ContratExpertise.new(ref,titre,desc,date_deb,date_fin,nb_jours,montant_jour))
	end	
end

# Classe ContratExpertise
#
# dfinition : Reprsente un contrat d'expertise
# attributs :
# - reference : La rfrence du contrat
# - titre : Le titre du projet / contrat
# - description : Une descriptions et des commentaires sur le contrat
# - date_debut : La date prvue de dbut du contrat
# - date_fin : La date prvue de fin du contrat
# - nb_jours : Le nombre de jours homme prvus dans le cadre du contrat
# - montant_jour : Le cot journalier d'une ressource. Le montant total 
#   du projet s'obtient par montant_jour*nb_jours

class ContratExpertise
	attr_reader :reference, :titre, :description, :date_debut, :date_fin, :nb_jours, :montant_jour

	# constructeur
	def initialize(ref,titre,desc,date_deb,date_fin,nb_jours,montant_jour)
    @reference = ref
    @titre = titre
    @description = desc
		@date_debut = date_deb
		@date_fin = date_fin
		@nb_jours = nb_jours
		@montant_jour = montant_jour
  end
  
	# Affiche les informations du client sur la sortie standard
	def to_s
    "Rfrence : #{@reference}\nTitre : #{@titre}\nDescription :\n#{@description}\nDate de dbut : #{@date_debut}\nDate de fin : #{@date_fin}\nMontant : #{@montant_jour}"
  end
end


# Classe ContratsSupport
#
# dfinition : gre une collection de contrats.

class ContratsSupport < Contrats
	
	# Ajoute un contrat  la liste des contrats existante
	def addContrat(ref,titre,desc,date_debut,date_fin,montant)
		@contrats.push(ContratSupport.new(ref,titre,desc,date_deb,date_fin,montant))
	end
end

# Classe ContratSupport
#
# dfinition : Reprsente un contrat de support
# attributs :
# - reference : La rfrence du contrat
# - titre : Le titre du projet / contrat
# - description : Une descriptions et des commentaires sur le contrat
# - date_debut : La date prvue de dbut du contrat
# - date_fin : La date prvue de fin du contrat
# - montant : Le montant HT du contrat

class ContratSupport
	attr_reader :reference, :titre, :description, :date_debut, :date_fin, :montant

	# constructeur
	def initialize(ref,titre,desc,date_deb,date_fin,montant)
    @reference = ref
    @titre = titre
    @description = desc
		@date_debut = date_deb
		@date_fin = date_fin
		@montant = montant
  end
  
	# Affiche les informations du client sur la sortie standard
	def to_s
    "Rfrence : #{@reference}\nTitre : #{@titre}\nDescription :\n#{@description}\nDate de dbut : #{@date_debut}\nDate de fin : #{@date_fin}\nMontant : #{@montant}"
  end
end


# Classe ContratsProduits
#
# dfinition : gre une collection de contrats.

class ContratsProduits < Contrats
	
	# Ajoute un contrat  la liste des contrats existante
	def addContrat(ref,titre,desc,montant)
		@contrats.push(ContratProduit.new(ref,titre,desc,date_deb,date_fin,montant))
	end
end

# Classe ContratProduit
#
# dfinition : Reprsente un contrat de produit
# attributs :
# - reference : La rfrence du contrat
# - titre : Le titre du contrat
# - description : La dsignation du ou des produits vendus
# - montant : Le montant HT du contrat
# - marge : La marge prvue sur le contrat (en valeur absolue)

class ContratProduit
	attr_reader :reference, :titre, :description, :montant, :marge

	# constructeur
	def initialize(ref,titre,desc,montant,marge)
    @reference = ref
    @titre = titre
    @description = desc
		@montant = montant
		@marge = marge
  end
  
	# Affiche les informations du client sur la sortie standard
	def to_s
    "Rfrence : #{@reference}\nTitre : #{@titre}\nDescription :\n#{@description}\nMontant : #{@montant}\nMarge : #{@marge}"
  end
end