# Classe Incidents
#
# dfinition : Gre une collection d'objets Incident qui reprsente l'ensemble des
# incidents lis aux contrats de support

class Incidents
	attr_reader :incidents	

	# constructeur
	def initialize
		@incidents = []
	end
	
	# Affiche la liste des incidents sur la sortie standard
	def to_s
		@incidents.each {|incident| puts(incident.to_s)}
	end

	# Ajoute un incident  la liste des incidents existants
	def addIncident(ref, titre, desc, date_ouv, date_ferm)
		@incidents.push(Incident.new(ref, titre, desc, date_ouv, date_ferm))
	end
	
	# Supprime de la liste des incidents l'incident dont l'identifiant est <id>
	def delIncident(ref)
		@incidents.delete_if {|incident| incident.reference==ref}
  end
end


# Classe Incident
#
# dfinition : Reprsente un incident
# - reference : la rfrence de l'incident (numro)
# - titre : le titre de l'incident
# - description : description de l'incident
# - date_ouverture : date d'ouverture de l'incident
# - date_fermeture : date de fermeture de l'incident

class Incident
	attr_reader :reference, :titre, :description, :date_ouverture, :date_fermeture

	# constructeur
	def initialize(ref,titre,desc,date_ouv,date_ferm)
		@reference = ref
		@titre = titre
		@description = desc
		@date_ouverture = date_ouv
		@date_fermeture = date_ferm
	end
	
	def to_s
		"Rfrence : #{@ident}\nTitre : #{@titre}\nDescription : #{@description}\nDate ouverture : #{@date_ouverture}\nDate fermeture : #{@date_fermeture}"
	end
end