# Classe Ressources
#
# dfinition : Gre une collection d'objets Ressource qui reprsente l'ensemble des
# ressources de la socit

class Ressources
	attr_reader :ressources	

	# constructeur
	def initialize
		@ressources = []
	end
	
	# Affiche la liste des ressources sur la sortie standard
	def to_s
		@ressources.each {|ressource| puts(ressource.to_s)}
	end

	# Ajoute une ressource  la liste de ressources existantes
	def addRessource(nom, prenom, fonction, salaire)
		@ressources.push(Ressource.new(nom, prenom, fonction, salaire))
	end
	
	# Renvoie l'objet ressource dont le nom est <nom>
	def getRessource(nom,prenom,fonction)
		@ressources.each do |ressource|
			if (ressource.nom==nom and ressource.prenom==prenom and ressource.fonction==fonction) then 
				return ressource
			end
		end
		return nil
	end
	
	# Supprime de la liste de ressources la ressource dont le nom est <nom> et le prenom <prenom>
	def delRessource(nom,prenom,fonction)
		@ressources.delete_if {|ressource| ressource.nom==nom and ressource.prenom==prenom and ressource.fonction==fonction}
  end
	
	# returns the number of resources registered in the object
	def length
		return @ressources.length
	end
	
	# empty the ressources list
	def clean
	 @ressources = []
	end
	
	# return a list of the resources whose function is COMMERCIAL
	def getCommerciaux
		@ressources.select {|ressource| ressource.fonction==Config::COMMERCIAL}
	end
	
	# return a list of the resources whose function is TECHNICIEN
	def getTechniciens
		@ressources.select {|ressource| ressource.fonction==Config::TECHNICIEN}
	end
end


# Classe Ressource
#
# dfinition : Reprsente une ressource humaine
# - nom : nom de la ressource
# - prenom : prnom de la ressource
# - fonction : fonction de la ressource (technicien, commercial, grant)
# - salaire : salaire brut de la ressource

class Ressource
	attr_reader :nom, :prenom, :fonction, :salaire

	# constructeur
	def initialize(nom,prenom,fonction,salaire)
		@nom = nom
		@prenom = prenom
		@fonction = fonction
		@salaire = salaire
	end
	
	def to_s
		"Nom : #{@nom}, Prnom : #{@prenom}, Fonction : #{@fonction}, Salaire brut : #{@salaire}"
	end
end